//
//  BookManager.m
//  DBReader
//
//  Created by Ibokan on 13-4-16.
//  Copyright (c) 2013年 刘浩. All rights reserved.
//

#import "BookManager.h"

#define KSqliteBook   [NSHomeDirectory() stringByAppendingFormat:@"/Documents/book.mo"]
@interface BookManager ()
{
    NSManagedObjectContext *        _context;
    NSManagedObjectModel    *       _model;
    NSPersistentStoreCoordinator *  _coordinator;
   
}

-(NSManagedObjectContext *)         _context;
-(NSManagedObjectModel *)           _model;
-(NSPersistentStoreCoordinator *)   _coordinator;
@end
@implementation BookManager
+(BookManager *)defaultBookManager;
{
    static  BookManager *bookM=nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        
        bookM=[[BookManager alloc] init];
    });
    return bookM;
    
}
-(id)init
{
    self= [super init];
    if (self) {
        
/*   
 if ([[NSFileManager defaultManager ]  fileExistsAtPath:KSqliteBook]) {
 [[NSFileManager defaultManager] removeItemAtPath:KSqliteBook error:nil];
 NSLog(@"ssdgsdg4613132");
 }else{
 [[NSFileManager defaultManager] createFileAtPath:KSqliteBook contents:nil attributes:nil];
 NSLog(@"sdgsdgsg'");
 }
 */
//        if ([[NSFileManager defaultManager ]  fileExistsAtPath:KSqliteBook]) {
//            [[NSFileManager defaultManager] removeItemAtPath:KSqliteBook error:nil];
//            NSLog(@"ssdgsdg4613132");
//        }else{
//            [[NSFileManager defaultManager] createFileAtPath:KSqliteBook contents:nil attributes:nil];
//            NSLog(@"sdgsdgsg'");
//        }
//


        
        [self _context];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(save11:) name:NSManagedObjectContextObjectsDidChangeNotification object:nil];
                //[self insert];
        
    }
    return self;
}
//测试数据
-(void)insert
{
    ReadBook *book1=[self readbook];
    ReadBook *book2=[self readbook];
    ReadBook *book3=[self readbook];
  
    book1.title=@"1";
    book2.title=@"2";
    book3.title=@"3";
}
//数据库保存跟检索方法
#pragma mark--GetBook
//保存一个book
-(ReadBook *)            readbook;
{
    //第一种
//    ReadBook * readbook=[[[ReadBook alloc] initWithEntity:[NSEntityDescription entityForName:@"ReadBook" inManagedObjectContext:[self _context]] insertIntoManagedObjectContext:[self _context]] autorelease];

    // 第二种
    ReadBook * readbook=[NSEntityDescription insertNewObjectForEntityForName:@"ReadBook" inManagedObjectContext:[self _context]];
    return readbook;
}
//保存评论
-(PingLun *)            pingLun;
{
    PingLun *pin=[NSEntityDescription insertNewObjectForEntityForName:@"PingLun" inManagedObjectContext:[self _context]];
    
    return pin;
}
//检索数据库
-(NSMutableArray *)bookMutableArry;
{
    //根据关键字排序
    NSSortDescriptor *sort=[NSSortDescriptor sortDescriptorWithKey:@"title" ascending:YES];
    //根据描述检索
   // NSPredicate *predicate=[NSPredicate predicateWithFormat:@"title="];
    NSFetchRequest *request=[NSFetchRequest fetchRequestWithEntityName:@"ReadBook"];
    [request setSortDescriptors:[NSArray arrayWithObject:sort]];
    //[request setPredicate:predicate];
    
    return [NSMutableArray arrayWithArray:[[self _context] executeFetchRequest:request error:nil ]];
}
-(NSMutableArray *)bookMutableArryTitle:(NSString *)bookid ;
{
    NSPredicate *predicate=[NSPredicate predicateWithFormat:@"bookId CONTAINS %@",bookid];
    NSFetchRequest *request=[NSFetchRequest fetchRequestWithEntityName:@"ReadBook"];
    [request setPredicate:predicate];
     return [NSMutableArray arrayWithArray:[[self _context] executeFetchRequest:request error:nil ]];
}
-(NSMutableArray *)pinLunMutableArryBookId:(NSString *)bookid;
{
    NSPredicate *predicate=[NSPredicate predicateWithFormat:@"bookId BEGINSWITH %@",bookid];
    NSFetchRequest *request=[NSFetchRequest fetchRequestWithEntityName:@"PingLun"];
    [request setPredicate:predicate];
    return [NSMutableArray arrayWithArray:[[self _context] executeFetchRequest:request error:nil]];
}
//删除
-(void)deleteObject:(id)object;
{
    [[self _context] deleteObject:object];
    [self save11:nil];
}
#pragma mark --NSManagedObject Creat
-(NSManagedObjectContext *)_context;
{
    if (_context) {
        return _context;
    }
    _context=[[NSManagedObjectContext alloc] initWithConcurrencyType:NSConfinementConcurrencyType];
    [_context setPersistentStoreCoordinator:[self _coordinator]];
    return _context;
    
}
-(NSManagedObjectModel *)_model;
{
    if (_model) {
        return _model;
    }
    _model=[[NSManagedObjectModel alloc] initWithContentsOfURL:[[NSBundle mainBundle] URLForResource:@"BookModel" withExtension:@"momd"]];
    
    return _model;
}
-(NSPersistentStoreCoordinator *)_coordinator;
{
    if (_coordinator) {
        return _coordinator;
    }
    _coordinator=[[NSPersistentStoreCoordinator  alloc] initWithManagedObjectModel:[self _model]];
    NSMutableDictionary *_options=[[[NSMutableDictionary alloc] init] autorelease];
    [_options setObject:@(YES) forKey:NSMigratePersistentStoresAutomaticallyOption];
    NSError *error;
    if (![_coordinator addPersistentStoreWithType:NSSQLiteStoreType configuration:nil URL:[NSURL fileURLWithPath:KSqliteBook] options:_options error:&error]) {
        abort();
    }
    
    
    return _coordinator;
}
-(void)save11:(NSNotification *)notification
{
    NSError *error=nil;
    if ([[self _context] hasChanges]&&![[self _context] save:&error]) {
        abort();
    }
    
}
@end
