//
//  DBViewController.m
//  DBReader
//
//  Created by Ibokan on 13-4-16.
//  Copyright (c) 2013年 刘浩. All rights reserved.
//

#import "DBViewController.h"
#import "BookCell.h"
#import "ContentViewController.h"
#import "LocalViewController.h"
#import <QuartzCore/QuartzCore.h>
#define SearchStartFrame        CGRectMake(0, -100,320,50)
#define SearchEndFrame          CGRectMake(0, 0,320,50)
@interface DBViewController ()
{
    NSInteger searchTotalcount;
    UIActivityIndicatorView * _activityIndicator;
    BOOL hasLastCell;
    NSInteger rowCount;
//    LocalViewController * _loc;
    BOOL isHidden;
    BOOL isAnimationing;
}
@property(nonatomic,retain)NSMutableArray *resultArray;
@property(nonatomic,retain)UITableView *tableView;
@property(nonatomic,retain)UISearchBar *searchba;



-(void)getRequeset:(NSString*)searchText startIN:(NSInteger)start countNumber:(NSInteger)count;
-(void)zhunahuanHuamian;
@end

@implementation DBViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        
        self.resultArray=[NSMutableArray array];
        self.title=@"搜索";
     self.tabBarItem=[[[UITabBarItem alloc] initWithTitle:@"搜索" image:[UIImage imageNamed:@"search.png"] tag:0] autorelease];
        self.view.backgroundColor=[UIColor colorWithPatternImage:[UIImage imageNamed:@"bizhi.jpg"]];
        // Custom initialization
    }
    return self;
}
-(void)dealloc
{
 
    [_localViewCon release];
    [_navigationlocalViewCon release];
    [_searBaButton release];
    [_activityIndicator release];
    [_resultArray release];
    [_tableView release];
    [_searchba release];
    [super dealloc];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
     self.navigationController.navigationBar.tintColor=[UIColor blackColor];

    //
    isHidden=NO;
    //
    isAnimationing=NO;
    hasLastCell =NO;
    //
    _activityIndicator=[[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleGray];
    _activityIndicator.frame=CGRectMake(30, 9, 50, 50);
    //左边搜索建
    UIBarButtonItem *bar=[[[UIBarButtonItem alloc] initWithImage:[UIImage imageNamed:@"search.png"] style:UIBarButtonItemStyleBordered target:self action:@selector(searchPutOut)] autorelease];
    self.searBaButton=bar;
    
    self.navigationItem.leftBarButtonItem=self.searBaButton;
    
    //搜索栏
    UISearchBar *search=[[UISearchBar alloc] initWithFrame:SearchStartFrame];
    [search setBarStyle:UIBarStyleBlack];
    search.delegate=self;
    [self.view addSubview:search];
    self.searchba=search;
    RELEAES(search);
    
    UITableView *tableView=[[UITableView alloc] initWithFrame:CGRectMake(0, 0,320,370)];
    [tableView setSeparatorStyle:UITableViewCellSeparatorStyleSingleLine];
    tableView.delegate=self;
    tableView.dataSource=self;
    tableView.rowHeight=71;
    rowCount=[self.resultArray count];
    self.tableView=tableView;
    
    RELEAES(tableView);
    //左导航建
    self.navigationItem.rightBarButtonItem=[[[UIBarButtonItem alloc] initWithTitle:@"书库" style:UIBarButtonSystemItemUndo target:self action:@selector(zhunahuanHuamian)] autorelease];
   	// Do any additional setup after loading the view.
}

-(void)searchPutOut
{
    [self.navigationController setNavigationBarHidden:YES animated:YES];
    //搜索栏未出现的时候
    [self.tableView removeFromSuperview];
    self.searchba.text=@"";
    [self.view addSubview:self.searchba];
    [UIView animateWithDuration:0.4 animations:^{
        self.searchba.frame=SearchEndFrame;
        searchTotalcount=0;
    }];
    
    
    
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
-(void)hideSearchBarAndShowNavigationBar
{
    [self.navigationController setNavigationBarHidden:NO animated:YES];
    [UIView animateWithDuration:0.4 animations:^{
        self.searchba.frame=SearchStartFrame;
        
    } completion:^(BOOL finished) {
        [self.searchba removeFromSuperview];
    }];
    [self.searchba resignFirstResponder];
}
#pragma mark-searchBar
- (BOOL)searchBarShouldBeginEditing:(UISearchBar *)searchBar;
{
    [searchBar setShowsCancelButton:YES animated:YES];
    return YES;
}
- (void)searchBarSearchButtonClicked:(UISearchBar *)searchBar;
{
    [self.resultArray removeAllObjects];
    rowCount=[self.resultArray count];
    [self.tableView reloadData];
    [self.view addSubview:self.tableView];
    [self hideSearchBarAndShowNavigationBar];
    [self getRequeset:searchBar.text startIN:0 countNumber:10];
    
}
- (void)searchBarCancelButtonClicked:(UISearchBar *) searchBar;
{
    //清空搜索栏 和tableview
    self.title=@"搜索";
    searchBar.text=@"";
    [self hideSearchBarAndShowNavigationBar];
    [self.tableView removeFromSuperview];
    [self.resultArray removeAllObjects];
    rowCount=[self.resultArray count];
    [self.tableView reloadData];
    
    
}
#pragma mark-tableViewDelegate
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section;
{
    if (hasLastCell) {
        return rowCount+1;
        NSLog(@"继续加载");
        
        
    }
    else {
        NSLog(@"结束");
        return rowCount;
    }
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    //最后一行显示 加载更多或者到底了;
    if (indexPath.row==[self.resultArray count]&&hasLastCell) {
        static NSString *indentifier=@"cell123";
        UITableViewCell *lastcell=[tableView dequeueReusableCellWithIdentifier:indentifier];
        if (!lastcell) {
            lastcell=[[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:indentifier]autorelease];
        }
        
        lastcell.textLabel.text=@"加载更多";
        lastcell.textLabel.textAlignment=NSTextAlignmentCenter;
        lastcell.tag=10;
        return lastcell;
        
    }
    
    
    static NSString *indentifier=@"cellin";
    BookCell *cell=(BookCell*)[tableView dequeueReusableCellWithIdentifier:indentifier];
    if (!cell) {
        cell=[[[BookCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:indentifier]autorelease];
    }
    Book *book=[self.resultArray objectAtIndex:indexPath.row];
    //赋值
    cell.book=book;
    return cell;
}
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    //
    

    [tableView deselectRowAtIndexPath:indexPath animated:NO];
    
    ContentViewController *content = [[ContentViewController alloc]init];
    content.delegate=self.localViewCon;
    content.loading=self.localViewCon.isloading;
    self.localViewCon.contentDelegate=content;
    
    content.book=[self.resultArray objectAtIndex:indexPath.row];
    content.title=content.book.title;
    [self.navigationController pushViewController:content animated:YES];
    [content release];
}
#pragma mark- -scrollViewDelegate
-(void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    if ([scrollView isEqual:self.tableView]) {
        
        if (scrollView.contentOffset.y>scrollView.contentSize.height-scrollView.frame.size.height-9&&!_activityIndicator.isAnimating) {
            NSLog(@"你妹");
            UITableViewCell *celll=[self.tableView cellForRowAtIndexPath:[NSIndexPath indexPathForRow:[self.resultArray count] inSection:0]];
            if (celll.tag==10)
            {
                 _activityIndicator.frame=CGRectMake(30, 9, 50, 50);
                [celll  addSubview:_activityIndicator];
                //菊花开转
                
                [_activityIndicator startAnimating];
                
                
                //网络获取更多
                [NSTimer scheduledTimerWithTimeInterval:0.9 target:self selector:@selector(getDataMore) userInfo:nil repeats:NO];
                //停下菊花；
                
            }
            
        }
        
        
    }
}
-(void)getDataMore
{
    [self getRequeset:self.searchba.text startIN:[self.resultArray count] countNumber:10];
}
//鲁迅
#pragma mark -requestGetData
-(void)getRequeset:(NSString*)searchText startIN:(NSInteger)start countNumber:(NSInteger)count;
{    _activityIndicator.center=self.view.center;
    [self.tableView addSubview:_activityIndicator];
    [_activityIndicator startAnimating];
    NSLog(@"sdgsgsg%@",searchText);
    NSURL *url=[NSURL URLWithString:[NSString stringWithFormat:@"https://api.douban.com/v2/book/search?apikey=%@&q=%@&start=%d&count=%d",KappKey,[searchText stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding],start,count]];
    
    NSURLRequest *request=[NSURLRequest requestWithURL:url];
    
    [NSURLConnection sendAsynchronousRequest:request queue:[NSOperationQueue mainQueue] completionHandler:^(NSURLResponse *re, NSData *data, NSError *err) {
        
        if (err) {
            return ;
            NSLog(@"dsgsg");
        }
        
        [self getdata:data];
    }];
}
-(void)getdata:(NSData *)data
{
    //菊花停止
    if (_activityIndicator.isAnimating) {
        [_activityIndicator stopAnimating];
    }
    NSString *jsonStr=[[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding] autorelease];
    NSDictionary *dic=[jsonStr JSONValue];
    //获取结果总数并显示
    
    searchTotalcount=[[dic objectForKey:@"total"] integerValue];
    self.title=[NSString stringWithFormat:@"总结果(%d)",searchTotalcount];
    self.tabBarItem.title=@"搜索";

    
    NSArray *array=[dic objectForKey:@"books"];
    
    hasLastCell=YES;
   
    if ([array count]<10) {
        NSLog(@"将要结束");
        hasLastCell=NO;
        
        if ([array count]==0&&[self.resultArray count]==0)
        {
                self.title=@"无结果";
                rowCount=[self.resultArray count];
                [self.tableView reloadData];
                return;
        }

    }
        
     
    //保存刷新之前的行数
    NSInteger lastRowCount=[self.resultArray count];
    //NSLog(@"%@",array);
    for (NSDictionary *booksDictiory  in array) {
        Book *searchbook=[[Book alloc] init];
        searchbook.authorName=[[booksDictiory objectForKey:@"author"] lastObject];
        searchbook.bookId=[booksDictiory objectForKey:@"url"];
        searchbook.imageStr=[booksDictiory objectForKey:@"image"];
        searchbook.pages=[booksDictiory objectForKey:@"pages"];
        searchbook.title=[booksDictiory objectForKey:@"title"];
        searchbook.publisher = [booksDictiory objectForKey:@"publisher"];
        searchbook.summary = [booksDictiory objectForKey:@"summary"];
        searchbook.author_intro=[booksDictiory objectForKey:@"author_intro"];
        
        [self.resultArray addObject:searchbook];
        [searchbook release];
        
    }
    
    rowCount=[self.resultArray count];
    //如果不是第一次出现 就插入
    if ([self.resultArray count]>10)
    {
        //定义最后一行 的参数
        
        //如果个数不够 插入就结束
        if (!hasLastCell)
        {
            rowCount=lastRowCount;
            [self.tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:[NSIndexPath indexPathForRow:lastRowCount inSection:0]] withRowAnimation:UITableViewRowAnimationNone];
                     
        }

            NSLog(@"哈哈哈哈%d",lastRowCount);
            NSLog(@"嘿嘿嘿嘿嘿嘿%d",[self.resultArray count]);
            NSMutableArray *indexArray=[NSMutableArray array];
            
            for (int i= lastRowCount; i<[self.resultArray count]; i++)
            {
                NSIndexPath *index=[NSIndexPath indexPathForRow:i inSection:0];
                [indexArray addObject:index];
            }
         rowCount=[self.resultArray count];
        [self.tableView insertRowsAtIndexPaths:indexArray withRowAnimation:UITableViewRowAnimationFade];
        
        
        return;
    }
    
    [self.tableView reloadData];
    //第一次出现tableView
    
}

-(void)zhunahuanHuamian
{
    UIWindow *window=self.navigationController.tabBarController.view.window;
    //1
    NSLog(@"dsfdsfsfd");

   //创建一个新的动画块
    [CATransaction begin];
    //
    [CATransaction setValue:[NSNumber numberWithFloat:0.9] forKey:kCATransactionAnimationDuration];
    //创建一个放大缩小的动画
    CABasicAnimation *shrinkAnimation=[CABasicAnimation animationWithKeyPath:@"transform.scale"];
    shrinkAnimation.delegate=self;
    shrinkAnimation.timingFunction=[CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseIn];
    //由toValue 的值来决定， 终点的大小
    shrinkAnimation.toValue=[NSNumber numberWithFloat:0.0f];
//   
//    CABasicAnimation *fade=[CABasicAnimation animationWithKeyPath:@"opacity"];
//    fade.toValue=[NSNumber numberWithFloat:0.0f];
//    fade.timingFunction=[CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseIn];
    
    CAKeyframeAnimation *positionAnimation=[CAKeyframeAnimation animationWithKeyPath:@"position"];
    //创建一个位置块
    CGMutablePathRef positonPaht=CGPathCreateMutable();
    //将位置块指向的选定图层
    CGPathMoveToPoint(positonPaht, NULL, window.layer.position.x, window.layer.position.y);
    //进行动画的位置块
    //CGPathAddQuadCurveToPoint(positonPaht, NULL, window.layer.position.x, -window.layer.position.y,window.layer.position.x, window.layer.position.y);
     CGPathAddQuadCurveToPoint(positonPaht, NULL, window.layer.position.x, -window.layer.position.y*0.75,window.layer.position.x, window.layer.position.y);
    CGPathAddQuadCurveToPoint(positonPaht, NULL, window.layer.position.x, -window.layer.position.y*0.5,window.layer.position.x, window.layer.position.y);
     CGPathAddQuadCurveToPoint(positonPaht, NULL, window.layer.position.x, -window.layer.position.y*0.25,window.layer.position.x, window.layer.position.y);
    positionAnimation.path=positonPaht;
    positionAnimation.timingFunction=[CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseIn];
     //添加动画到图层
  // [window.layer addAnimation:fade forKey:@"fade"];
   [window.layer addAnimation:shrinkAnimation forKey:@"shrinkAnimation"];
    [window.layer addAnimation:positionAnimation forKey:@"positionAnimation"];
    
    [CATransaction commit];
    //2
    //[self transformController:NO FromviewController:self.navigationController.tabBarController toviewController:self.localViewCon];
    

}

-(void)animationDidStop:(CAAnimation *)anim finished:(BOOL)flag
{
   
    [self.navigationController.tabBarController  dismissViewControllerAnimated:NO completion:^{
        [self.localViewCon appearewithAnimation];
    }];
    
}


//页面翻转动画
-(void)transformController:(BOOL)ishidden FromviewController:(UIViewController *)Viewcontroller toviewController:(UIViewController *)toView;
{
    [Viewcontroller  dismissViewControllerAnimated:NO completion:^{
        
    }];
     [UIView beginAnimations:@"wcss" context:NULL];
    [UIView setAnimationDuration:0.4];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseIn];
    UIWindow *window=toView.view.window;
    [UIView setAnimationTransition:UIViewAnimationTransitionFlipFromLeft forView:window cache:NO];
    toView.view.hidden=NO;
    
  
    [UIView commitAnimations];
    
    
}


#pragma mark-LocalBookMethord


@end
