//
//  ReadingViewController.m
//  douBan
//
//  Created by Ibokan on 13-4-26.
//  Copyright (c) 2013年 ibokan. All rights reserved.
//

#import "ReadingViewController.h"
#import <QuartzCore/QuartzCore.h>
@interface ReadingViewController ()
{
    NSInteger textCount;
    NSInteger totleCount;
    BOOL ishiden;
}
@property(nonatomic,retain)UITextView *textView;
@end

@implementation ReadingViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
-(void)dealloc
{
    [_textView release];
    [super dealloc];
}
- (void)viewDidLoad
{
    [super viewDidLoad];
    ishiden=NO;
    textCount=0;
    NSData *data=[NSData dataWithContentsOfFile:self.filePath];
    NSStringEncoding encode=CFStringConvertEncodingToNSStringEncoding(kCFStringEncodingGB_18030_2000);
    
    NSString *str=[[[NSString alloc] initWithData:data encoding:encode] autorelease];

    UITextView *textV=[[UITextView alloc] initWithFrame:self.view.bounds];
    textV.backgroundColor=[UIColor whiteColor];
    textV.text=str;
    textV.font=[UIFont systemFontOfSize:18];
    textV.editable=NO;
    textV.scrollEnabled=NO;
    [textV sizeToFit];
    textV.userInteractionEnabled=YES;
    UISwipeGestureRecognizer *swipRight=[[[UISwipeGestureRecognizer alloc] initWithTarget:self action:@selector(goNext:)] autorelease];
    [swipRight setDirection:UISwipeGestureRecognizerDirectionLeft];
    [textV addGestureRecognizer:swipRight];
    UISwipeGestureRecognizer *swipLeft=[[[UISwipeGestureRecognizer alloc] initWithTarget:self action:@selector(goForward:)] autorelease];
    [swipLeft setDirection:UISwipeGestureRecognizerDirectionRight];
    [textV addGestureRecognizer:swipLeft];
    UITapGestureRecognizer *tapgesture=[[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(gogogo:)] autorelease];
    tapgesture.numberOfTapsRequired=1;
    [textV addGestureRecognizer:tapgesture];
    
    [self.view addSubview: textV];
    
    self.textView=textV;
    totleCount=self.textView.contentSize.height/405+1;
    [textV release];
    
      
	// Do any additional setup after loading the view.
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
     self.title=[NSString stringWithFormat:@"%d/%d",textCount+1,totleCount+1];
}
-(void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    [UIView animateWithDuration:0.5 animations:^{
        if (self.tabBarController) {
            
            self.tabBarController.view.frame=CGRectMake(0, 0, 320, 528);
        }
        
        
    }];
    
}
-(void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    self.tabBarController.view.frame=CGRectMake(0, 0, 320, 480);
    
}

-(void)hideNavigation:(UITapGestureRecognizer*) gesture
{
    ishiden=!ishiden;
    [self.navigationController setNavigationBarHidden:ishiden animated:YES];
}
-(void)goNext:(UISwipeGestureRecognizer *)gesture
{  if (textCount ==totleCount)
{
    UIAlertView *alertView=[[[UIAlertView alloc] initWithTitle:@"提示" message:@"已经是最后一页" delegate:self cancelButtonTitle:@"确定"otherButtonTitles:nil] autorelease];
    [alertView show];
    return;
}
    textCount++;

    [self skipToPageWithSubtype:kCATransitionFromRight];
    
}
-(void)goForward:(UISwipeGestureRecognizer *)gesture
{
    if (textCount==0) {
        UIAlertView *alertView=[[[UIAlertView alloc] initWithTitle:@"提示" message:@"已经是首页" delegate:self cancelButtonTitle:@"确定"otherButtonTitles:nil] autorelease];
        [alertView show];
        return;
    }
    textCount--;
    [self skipToPageWithSubtype:kCATransitionFromLeft];
    
}
-(void)skipToPageWithSubtype:(NSString *)subtye
{
    CATransition *animation=[CATransition animation];
    animation.timingFunction=UIViewAnimationCurveEaseInOut;
    animation.duration=0.4;
//    animation.type=@"cube";
    animation.type=kCATransitionPush;
    animation.subtype=subtye;
    [self.textView.layer addAnimation:animation forKey:@"animation"];
    self.textView.contentOffset=CGPointMake(0, 400*textCount);
    self.title=[NSString stringWithFormat:@"%d/%d",textCount+1,totleCount+1];
}
-(void)gogogo:(UITapGestureRecognizer *)tapgesture
{
    
    CGPoint pp=[tapgesture locationInView:self.textView];
   
    if (pp.x<120) {
        //左翻页
        [self goForward:nil];
        
    }
    if (pp.x>200) {
        //右翻页
        [self goNext:nil];
        
    }
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
